Welcome to EMS Data Comparer!

EMS Data Comparer for Oracle is a powerful and easy-to-use utility for data comparison and synchronization. You can view all the differences in the tables being compared and execute an automatically generated script to eliminate these differences. With flexible customization of the comparison and synchronization process you can select tables and fields for comparison and tune many other options. Data Comparer for Oracle includes a graphical wizard guiding you through the data comparison and synchronization process step by step, and a command-line service for synchronizing data in one-touch.

Visit our web-site: https://www.sqlmanager.net/ for details.

Key features

  • User-friendly wizard interface
  • Data comparison of several tables simultaneously
  • Automatic and manual selection of data being compared
  • Wide range of synchronization parameters
  • Unicode data support
  • Partial data synchronization
  • Saving data synchronization script to a file for future use
  • The ability saving all the parameters specified within the current wizard session
  • The command-line utility to compare and synchronize data with a template used
  • The possibility to compare data using filters

Product information

Homepage: | https://www.sqlmanager.net/products/oracle/datacomparer
Support Ticket System: | https://www.sqlmanager.net/support
Register online at: | https://www.sqlmanager.net/products/oracle/datacomparer/buy


What's new

Data Comparer for Oracle
  • Index
  • « Prev
  • Next »

What's new?

Version | Release date
Data Comparer for Oracle 4.0 | August 2, 2024

What's new in Data Comparer 4.0?

  • Dark visual schema is now available in the application.
  • SSL connection added for InterBase/Firebird, MySQL/MariaDB, PostgreSQL servers.
  • Unicode object names are now supported.
  • Added support for Windows 11 ARM.
  • SSH library upgraded to support ECDSA, Ed25519 keys and Keyboard-interactive authentication method.
  • All latest server versions are supported: Firebird 5, SQL Server 2022, MySQL 8, PostgreSQL 16.
  • Restart wizard option added at the last step of the wizard.
  • Improved processing of scripts for data synchronization.
  • Many other improvements and fixes.

See also:

Version history


System requirements

System requirements

  • Microsoft® Windows XP, Microsoft® Windows 2003 Server, Windows® 2008 Server, Microsoft® Windows Vista, Microsoft® Windows 7, Microsoft® Windows 8, Microsoft® Windows 2012 R2 Server, Microsoft® Windows 2012 Server, Microsoft® Windows 8.1, Microsoft® Windows 10, Microsoft® Windows 2016 Server, Microsoft® Windows 2019 Server, Microsoft® Windows 11, Microsoft Windows 11 ARM
  • 512 MB RAM or more; 1024 MB or more recommended
  • 50 MB of available HD space for program installation
  • Oracle Client 8.1.7 or higher
  • Possibility to connect to any local or remote Oracle server
  • Supported Oracle server versions: from 8.1.7 up to 21c


Installation

If you are installing Data Comparer for Oracle for the first time on your PC:

  • download the Data Comparer for Oracle distribution package from the download page available at our site;
  • unzip the downloaded file to any local directory, e.g. C:\unzipped;
  • run OraDataComparerSetup.exe from the local directory and follow the instructions of the installation wizard;
  • after the installation process is completed, find the Data Comparer shortcut in the corresponding group of Windows Start menu.

If you want to upgrade an installed copy of Data Comparer for Oracle to the latest version:

  • download the Data Comparer for Oracle distribution package from the download page available at our site;
  • unzip the downloaded file to any local directory, e.g. C:\unzipped;
  • close Data Comparer application if it is running;
  • run OraDataComparerSetup.exe from the local directory and follow the instructions of the wizard.

See also:

System requirements


Registration

All purchases are provided by PayPro Global registration service. The PayPro Global order process is protected via a secure connection and makes on-line ordering by credit/debit card quick and safe.

PayPro Global is a global e-commerce provider for software and shareware sales via the Internet. It accepts payments in US Dollars, Euros, Pounds Sterling, Japanese Yen, Australian Dollars, Canadian Dollars or Swiss Franks by Credit Card (Visa, MasterCard/EuroCard, American Express, Diners Club), Bank/Wire Transfer.

If you want to review your order information, or you have questions about ordering or payments please visit our PayPro Global Shopper Support, provided by PayPro Global.

Please note that all of our products are delivered via ESD (Electronic Software Delivery) only. After purchase you will be able to immediately download the registration keys. Also you will receive a copy of registration keys by email. Please make sure to enter a valid email address in your order. If you have not received the keys within 2 hours, please, contact us at sales@sqlmanager.net.

Product distribution | PayPro Global
EMS Data Comparer for Oracle (Business license) + 1-Year Maintenance* | Register Now!
EMS Data Comparer for Oracle (Business license) + 2-Year Maintenance*
EMS Data Comparer for Oracle (Business license) + 3-Year Maintenance*
EMS Data Comparer for Oracle (Non-commercial license) + 1-Year Maintenance*
EMS Data Comparer for Oracle (Non-commercial license) + 2-Year Maintenance*
EMS Data Comparer for Oracle (Non-commercial license) + 3-Year Maintenance*
EMS Data Comparer for Oracle (Trial version) | Download Now!

*EMS Maintenance Program provides the following benefits:

  • Free software bug fixes, enhancements, updates and upgrades during the maintenance period
  • Free unlimited communications with technical staff for the purpose of reporting Software failures
  • Free reasonable number of communications for the purpose of consultation on operational aspects of the software

After your maintenance expires, you will not be able to update your software or get technical support. To protect your investments and have your software up-to-date, you need to renew your maintenance.

You can easily reinitiate/renew your maintenance with our online, speed-through Maintenance Reinstatement/Renewal Interface. After reinitiating/renewal you will receive a confirmation e-mail with all the necessary information.

See also:

How to register EMS Data Comparer


How to register EMS Data Comparer

To register your newly purchased copy of EMS Data Comparer for Oracle, perform the following:

  • receive the notification letter from PayPro Global with the registration info;
  • enter the Registration Name and the Registration Key from this letter into the Register Data Comparer for Oracle form at the Welcome Step;
  • make sure that the registration process has been completed successfully – check the registration information at the startup page.

Welcome to Data Comparer - Register product

See also:

Registration


Version history

Product name

Version

Release date

Data Comparer for Oracle

Version 3.5.3

February 9, 2023

Data Comparer for Oracle

Version 3.5.2

February 13, 2020

Data Comparer for Oracle

Version 3.5.1

July 27, 2016

Data Comparer for Oracle

Version 3.5.0

November 15, 2012

Data Comparer for Oracle

Version 3.4.0.1

March 7, 2012

Data Comparer 2011 for Oracle

Version 3.3.0.1

August 29, 2011

Data Comparer 2011 for Oracle

Version 3.2.0.1

March 21, 2011

Data Comparer 2010 for Oracle

Version 3.1.0.1

November 01, 2010

Data Comparer 2010 for Oracle

Version 3.0.0.1

May 04, 2010

Data Comparer 2010 for Oracle

Version 2.3.0.1

March 10, 2009

Data Comparer 2007 for Oracle

Version 2.2.0.1

October 2, 2008

Data Comparer 2007 for Oracle

Version 2.1.0.1

December 19, 2007

Data Comparer 2007 for Oracle

Version 2.0.0.1

June 6, 2007

Version 3.5.3

  • Added support for new Oracle 21c server version.
  • Minor fixes and improvements.

Version 3.5.2

  • Added support for new server versions: SQL Server 2017, MySQL Server 8, PostgreSQL 12.
  • Support for Azure SQL Database implemented.
  • FB/IB. Fixed synchronization of TIME and DATETIME data types with milliseconds.
  • FB/IB. Support for BOOLEAN type implemented.
  • FB/IB. Triggers were not disabled correctly. Fixed now.
  • MySQL. The 'MySQL has gone away' error has been fixed.
  • PostgreSQL. The MATCH option is now processed correctly on creating FK.
  • Other fixes and improvements.

Version 3.5.1

  • Comparing and synchronization of big tables has been considerably improved.
  • The speed of comparing BLOB fields has been increased.
  • Now BINARY fields can be selected as key fields for comparison.
  • Field list was not refreshed on changing the tables. Fixed now.
  • The selected charset was not applied to the SQL-script. Fixed now.
  • The errors on loading the template file have been fixed.
  • Some other improvements and bug-fixes.

Version 3.5.0

  • Added the possibility to manually set a list of synchronized records.
  • Now it is possible to check for active triggers in the synchronized tables. If there are triggers in the target table, you will be prompted to disable them.
  • Added the possibility to set filters on the basis of the LIKE operator.
  • The console version of Data Comparer for Oracle did not connect to the server through the TNS_ADMIN environment variable. Fixed now.
  • Now at the "Setting tables correspondence" step a filter can be viewed as the pop-up window.

Version 3.4.0.1

  • Now the comparison results can be exported to MS Excel 2007.
  • The progress window now displays the time remaining and the number of records per second.
  • Data Filter. Added the OR and AND operations.
  • When selecting text fields as key fields, the table comparison speed significantly increased.
  • Added the possibility to save a template at any step of the wizard.
  • Some other improvements and bugfixes.

Version 3.3.0.1

  • Added the possibility to compare data using filters;
  • Added the "Trim CHAR Fields" option, which allows to trim spaces in CHAR and NCHAR fields while comparing and synchronizing data;
  • Added the Jump List with a list of templates for Windows 7;
  • If while synchronizing data, the number of records returned from the server is smaller than the expected amount to be synchronized (i.e. because of triggers), now a warning is written to the log-file;
  • Added the path parameter to the log file in the console version;
  • Some other improvements and bugfixes.

Version 3.2.0.1

  • RAM usage is optimized. Now the product consumes less memory when working with large tables.
  • Added the new option - ‘Fill correspondence automatically’ for the console version. When enabled, new tables in the database (created after generating a template) are also synchronized and compared when databases are compared.
  • When loading a template, the application can now ask for a password for the database if necessary.
  • Added the possibility to encrypt passwords in the template.
  • Sometimes table data were sorted incorrectly when displaying comparison results. Fixed now.
  • When synchronizing databases located on one server, it is now possible to generate synchronization scripts containing table data.
  • Added hints for options located on the application forms.
  • Other minor improvements and bugfixes.

Version 3.1.0.1

  • Added the ‘Disable foreign keys’ option on the Step 4 - Specifying data synchronization options which allows disabling foreign keys when inserting or modifying data.
  • The ‘Before synchronization script’ and ‘After synchronization script’ on the Step 7 - Specifying additional scripts are now executed in the same connection context where the synchronization is performed.
  • Script Editor. When saving and re-opening the editor, the character set chosen in the previous session is saved.
  • If any database errors occur during the comparison process, the program informs about errors and offers to continue. The error texts are displayed as a hint in the Summary dialog.
  • BLOB Editor. Added the possibility to view texts in Unicode.
  • The process of selecting tables to compare has become more convenient.
  • Added the possibility to disable the code folding in editors.
  • Added the possibility to export comparison results of all tables at once.
  • Added the possibility to use filters during the code completion.
  • Some other small bugfixes and improvements.

Version 3.0.0.1

  1. The comparison and synchronization algorithm is significantly improved and is optimized for working with large databases:
  • The comparison speed is considerably increased, in some cases up to 5 times.
  • The synchronization speed is increased, especially in cases when compared tables are located on one server.
  • The amount of the consumed RAM is reduced, now it does not depend on the number of records in compared tables which allows avoiding the Out of Memory error.
  • The speed of auto-fill in tables and fields is increased.
  2. Added the possibility to synchronize BLOB fields in InterBase.
  3. Added the option for viewing the Summary for the compared objects at the Step 3 - Browsing data comparison results.
  4. Synchronization with deleting of records from tables containing foreign keys could result in an error. Fixed now.
  5. Added the possibility to clear the template list.
  6. Some other small bugfixes and improvements.

Version 2.3.0.1

  • Added the Commit after synchronization option allowing to rollback all changes if an error occurs during the synchronization process.
  • Added the possibility to define table synchronization order manually.
  • Added the possibility to generate a summary report with table comparison results.
  • It is now possible to sort and filter comparison results.
  • Encrypted passwords within templates created with older versions of the utility could not be read properly. Fixed now.
  • Some other small bugfixes and improvements.

Version 2.2.0.1

  • Added tools for exporting comparison results to HTML and RTF
  • Added support of object tables
  • The new enhanced Script Editor
  • Added the possibility to output the detailed error description in the console application
  • Optimized the script generation mechanism: now only different fields are added to the synchronization script
  • Added tools for printing synchronization logs
  • Other minor improvements and bug-fixes

Version 2.1.0.1

  • Now you are able to set up SQL statement batches which will be executed before and/or after the synchronization process
  • The possibility to select DB schemas for data comparison is added
  • Tables for which the set of key fields differs from primary key fields are synchronized significantly faster now
  • Table lists are sorted by table and schema name now
  • The possibility to save synchronization logs to a file is implemented
  • The number of DB connections coincides with the number of selected threads
  • Other minor improvements and bug-fixes

Version 2.0.0.1

  • Multi-threading for data comparison
  • Boosted synchronization speed
  • A more convenient way of browsing differences in compared data
  • Implementation of the Find Text dialog in Script editor
  • Processing of Foreign keys implemented
  • An opportunity to select tables after data comparison
  • Export of comparison results to MS Excel documents
  • The ‘Detailed error messages’ option at the synchronization step
  • Encrypted passwords storage

See also:

What's new


EMS Data Comparer FAQ

Please read this page attentively if you have questions about EMS Data Comparer for Oracle.

Table of contents

  • What is EMS Data Comparer?
  • What do I need to start working with EMS Data Comparer?
  • What is the easiest way to configure the template files for Data Comparer console application?
  • How can I register the application?
  • Are there any limitations implied in the trial version as compared with the full one?
  • How can I automate comparison and synchronization process?

Question/answer list

Q: What is EMS Data Comparer?

A: EMS Data Comparer for Oracle is a powerful and easy-to-use utility for data comparison and synchronization which allows you to view differences in tables and execute an automatically generated script to synchronize data between these tables. Data Comparer for Oracle includes a GUI wizard which guides you through the data comparison and synchronization process step by step, and a command-line version for synchronizing data in one-touch.

Q: What do I need to start working with EMS Data Comparer for Oracle?

A: First of all, you must have a possibility to connect to some local or remote Oracle server to work with Data Comparer. You can download Oracle database server from https://www.oracle.com/technology/software. Besides, you need your workstation to satisfy the system requirements of Data Comparer for Oracle.

Q: What is the easiest way to configure the template files for Data Comparer console application?

A: You can configure the template files visually using the Data Comparer Wizard. Set all the necessary options in each step of the wizard and click the Tools | Save template button. All the options will be saved to the template file which can be used afterwards in the console application.

Q: How can I register the application?

A: If you have already purchased Data Comparer for Oracle, you can register the product by entering the appropriate registration information. Please refer to Registration and How to register EMS Data Comparer for details.

Q: Are there any limitations implied in the trial version as compared with the full one?

A: The trial version of the utility allows to compare and synchronize no more than 10 tables. As for the rest, the functionality of the trial version does not differ from the full one. You can test the features implemented in Data Comparer for Oracle within the 30-day trial period for free.

Q: How can I automate comparison and synchronization process?

A: First go through all steps of the wizard setting the necessary options and save the template at the last step of the wizard. The template can be run with the console version of the utility from the command line. You can schedule the launch of the console with the template name as a parameter using native Windows Scheduler tool.

Scroll to top

If you still have any additional questions, please contact us at our Support Center.


Other EMS Products

Quick navigation

MySQL

Microsoft SQL Server

PostgreSQL

InterBase / FireBird

Oracle

IBM DB2

Tools & components

MySQL

 | SQL Management Studio for MySQL EMS SQL Management Studio for MySQL is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for MySQL Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for MySQL Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for MySQL Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for MySQL Migrate from most popular databases (MySQL, PostgreSQL, Oracle, DB2, InterBase/Firebird, etc.) to MySQL.
datagenerator | Data Generator for MySQL Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for MySQL Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for MySQL Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for MySQL Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for MySQL Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

Microsoft SQL Server

 | SQL Management Studio for SQL Server EMS SQL Management Studio for SQL Server is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | EMS SQL Backup for SQL Server Perform backup and restore, log shipping and many other regular maintenance tasks on the whole set of SQL Servers in your company.
sqladmin | SQL Administrator for SQL Server Perform administrative tasks in the fastest, easiest and most efficient way. Manage maintenance tasks, monitor their performance schedule, frequency and the last execution result.
 | SQL Manager for SQL Server Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for SQL Server Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for SQL Server Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for SQL Server Migrate from most popular databases (MySQL, PostgreSQL, Oracle, DB2, InterBase/Firebird, etc.) to Microsoft® SQL Server™.
datagenerator | Data Generator for SQL Server Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for SQL Server Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for SQL Server Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for SQL Server Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for SQL Server Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

PostgreSQL

 | SQL Management Studio for PostgreSQL EMS SQL Management Studio for PostgreSQL is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | EMS SQL Backup for PostgreSQL Creates backups for multiple PostgreSQL servers from a single console. You can use automatic backup tasks with advanced schedules and store them in local or remote folders or cloud storages
 | SQL Manager for PostgreSQL Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for PostgreSQL Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for PostgreSQL Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for PostgreSQL Migrate from most popular databases (MySQL, SQL Server, Oracle, DB2, InterBase/Firebird, etc.) to PostgreSQL.
datagenerator | Data Generator for PostgreSQL Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for PostgreSQL Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for PostgreSQL Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for PostgreSQL Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for PostgreSQL Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

InterBase / Firebird

 | SQL Management Studio for InterBase/Firebird EMS SQL Management Studio for InterBase and Firebird is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for InterBase/Firebird Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for InterBase/Firebird Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for InterBase/Firebird Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for InterBase/Firebird Migrate from most popular databases (MySQL, SQL Server, Oracle, DB2, PostgreSQL, etc.) to InterBase/Firebird.
datagenerator | Data Generator for InterBase/Firebird Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for InterBase/Firebird Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for InterBase/Firebird Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for InterBase/Firebird Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for InterBase/Firebird Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

Oracle

 | SQL Management Studio for Oracle EMS SQL Management Studio for Oracle is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for Oracle Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for Oracle Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for Oracle Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for Oracle Migrate from most popular databases (MySQL, PostgreSQL, MySQL, DB2, InterBase/Firebird, etc.) to Oracle
datagenerator | Data Generator for Oracle Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for Oracle Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for Oracle Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for Oracle Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for Oracle Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

IBM DB2

 | SQL Manager for DB2 Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for DB2 Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for DB2 Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for DB2 Migrate from most popular databases (MySQL, PostgreSQL, Oracle, MySQL, InterBase/Firebird, etc.) to DB2
datagenerator | Data Generator for DB2 Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
extract | DB Extract for DB2 Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for DB2 Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
 | Scroll to top

Tools & components

advancedexport | Advanced Data Export for RAD Studio VCL Advanced Data Export for RAD Studio VCL allows you to save your data in the most popular office programs formats.
advancedexport | Advanced Data Export .NET Advanced Data Export .NET is a component for Microsoft Visual Studio .NET that will allow you to save your data in the most popular data formats for the future viewing, modification, printing or web publication. You can export data into MS Access, MS Excel, MS Word (RTF), PDF, TXT, DBF, CSV and more! There will be no need to waste your time on tiresome data conversion - Advanced Data Export will do the task quickly and will give the result in the desired format.
advancedimport | Advanced Data Import for RAD Studio VCL Advanced Data Import for RAD Studio VCL will allow you to import your data to the database from files in the most popular data formats.
pdfgenerator | Advanced PDF Generator for RAD Studio Advanced PDF Generator for RAD Studio gives you an opportunity to create PDF documents with your applications written on Delphi or C++ Builder.
querybuilder | Advanced Query Builder for RAD Studio VCL Advanced Query Builder for RAD Studio VCL is a powerful component for Delphi and C++ Builder intended for visual building SQL statements for the SELECT, INSERT, UPDATE and DELETE clauses.
excelreport | Advanced Excel Report for RAD Studio Advanced Excel Report for RAD Studio is a powerful band-oriented generator of template-based reports in MS Excel.
advancedlocalizer | Advanced Localizer for RAD Studio VCL Advanced Localizer for RAD Studio VCL is an indispensable component for Delphi for adding multilingual support to your applications.
 | Scroll to top


Using Wizard Application

Data Comparer for Oracle Wizard guides you through the entire comparison and synchronization process and provides an easy-to-use graphical interface allowing you to set all data comparison parameters visually.

Navigation through the steps of the wizard is performed with the help of the Next> and the <Back buttons.

Use the Tools button for calling the Preferences dialog or to load/save a template.

Go through the steps of the wizard and follow the wizard instructions to tune all necessary comparison options according to your needs:

Getting started

Step 1 - Setting connection properties

Step 2 - Setting tables and fields correspondence

Step 3 - Browsing data comparison results

Step 4 - Specifying data synchronization options

Step 5 - Setting synchronization order

Step 6 - Editing synchronization script

Step 7 - Specifying additional scripts

Step 8 - Start of synchronization process

See also:

Using console application

Using templates

Setting program preferences


Getting started

This is how Data Comparer for Oracle application wizard looks when you first start it.

This page allows you to view registration information. If you have not registered Data Comparer for Oracle yet, you can do it by pressing the Enter Registration Code... button and specifying your registration information.

Application wizard - Getting started

Press the Next button to proceed to the next step.


Step 1 - Setting connection properties

At this step you should specify necessary settings to establish connection to Oracle databases.

Step 1 - Setting connection properties

Connection settings

Database home

Specify your Oracle Home storage for this connection.

Note: If no database is registered in Oracle Client (DB list is empty in this case) you need to add registration info manually.

Connect as

Select the type of connection to be established: Normal (by default), SYSDBA, SYSOPER.

Authentication

Specify the type of authentication to be used for the connection: Windows or Server authentication.

If Server has been selected as the authentication type, you should also provide authorization settings: Login and Password.

The default superuser name is 'SYS' (for Oracle 9.0 and higher) and the default password is 'change_on_install'.

After that it is necessary to select the database for data comparison: use the Database drop-down list to select the database you need (the drop-down list contains databases currently specified in the TNS file).

Please note that you need to have sufficient privileges to be able to write to the destination database on Oracle server.

Tunneling settings

Step 1 - Setting connection properties - Tunneling

SSH host name

Set the name of the host where SSH server is running.

SSH port

Indicate the port where SSH server is activated.

SSH login

Specify the user on the machine where SSH server is running (Note: it is a Linux/Windows user, not a user of Oracle server).

SSH password

Input the Linux/Windows user password.

CheckBox Use Private Key for authentication

If the SSH encryption is enabled on the SSH server, a user can generate a pair of cryptographic keys (the Private key and the Public key). The Public key is placed on the SSH server, and the Private key is the part you keep secret inside a secure box that can only be opened with the correct passphrase (or an empty string as the passphrase). When you wish to access the remote system, you open the secure box with your passphrase (if any), and use the private key to authenticate yourself with the Public key on the remote Linux computer.

SSH Key file

Specify the location (the secure box) of the Private key file on your local machine.

Note that you need to trust your local machine not to scrape your passphrase or a copy of your Private key file while it is out of its secure box. For more details see SSH tunneling options.

Repeat the steps above for the target Oracle connection or just check the Both databases are located on the same server option for comparing data from databases located on the same server.

When you are done, press the Next button to proceed to the selecting schemas for refreshing or directly to Step 2 (if the Select schemas... dialog is disabled in the program preferences).


Selecting schemas for refreshing

Before you proceed to the Setting tables and fields correspondence step of the wizard, you are offered to specify the schemas to be refreshed using the Select schemas for refreshing... dialog.

Hint: For your convenience the context menu is available in both the Source schemas and Target schemas lists. Using the context menu you can iconCheckAll Check all, iconUncheckAll Uncheck all and iconInvertSelection Invert items selection in the lists.

Step 1 - Selecting schemas for refreshing

CheckBox Refresh all schemas and don't show this window in the future

Set this option to specify all of your Oracle schemas for refreshing and skip this dialog in the future sessions of the wizard.

Note: To activate/deactivate this dialog, use the Show select schemas window option in the General section of the Preferences dialog.

When you are done, press OK to proceed to Step 2 of the wizard.


Selecting registered database

Use this dialog to select a database for comparison. This dialog is available only in EMS SQL Management Studio version of Data Comparer for Oracle.

Selecting registered database

All databases registered in EMS SQL Management Studio for Oracle are displayed in the list.

Select the necessary database and click the OK button.

Database registration information will be filled on the first step automatically.


Step 2 - Setting tables and fields correspondence

At this step you should select objects for data comparison.

Step 2 - Setting tables and fields correspondence

Setting table correspondence

The upper grid allows you to set correspondence between tables of the source and the target databases. If you wish to setup correspondence between tables (as well as between their fields) automatically on the basis of equivalence of their names, press the Autofill tables and fields button. If no correspondence is set for a table, it will not be included in the data comparison process.

kpfkpk

For your convenience the Mask for autofill of object names is added. The filter is intended for excluding unnecessary tables from auto filling.

You can use standard wildcards like asterix (*) or percent sign (%) which are the same, or the question mark (?). To exclude the object names set in the filter, use the exclamation mark (!) at the beginning, e.g. the result for !T* stands for all objects except the object names starting with T. If any of these symbols presents the name of the object and you do need to apply filter to them, just double that symbol, e.g. the result for !!T* will result in all objects with names that start with !T.

Data Filter

Click the btnEllipsis button in the Data Filter column to set filter for comparing data. Only data within specified condition will be compared and synchronized.

Use Data Filter - Add \ Data Filter - Remove buttons to Add\Remove conditions and drop-down lists to select column names and operators.

Note: You can apply either OR or AND operator between conditions.

Step 2 - Data Filter

Setting field correspondence

The lower grid allows you to set correspondence between table fields of the source and the target databases. If you wish to set up correspondence between table fields automatically on the basis of equivalence of their names, press the Autofill fields button. Please note that you can set field correspondence for fields of identical data types only. If no correspondence is set for a field, it will not be included in the data comparison process.

Tick off the checkboxes in the Key Field column for those fields which will be used as key columns to determine appropriate records in the tables being compared. Please keep in mind that you can define a key field only after a correspondence has been set for this field.

Note: you can define options for multiple tables/fields at a time by using the context menus implemented for your convenience in the Setting table correspondence and the Setting field correspondence grids.

Attention! You should define at least one key field for each pair of tables, otherwise they will be painted red, and you will be unable to proceed.

CheckBox Ignore case when comparing strings

Set this option for case-insensitive comparison of strings.

CheckBox Compare BLOB values

Set this option to compare the content of the BLOB fields.

CheckBox Trim CHAR fields

Set this option to trim CHAR fields on synchronization. Note, that if data only contains spaces it will be regarded as empty string (''). If the option is off data is processes as is (including spaces at the end of the string).

Note: Oracle server treats empty strings as NULLs.

RadioButton Use LOCK TABLES statement

If this option is checked, the LOCK TABLES statement blocking the tables within the comparison session is executed.

Upon successful completion of this statement no other transaction can update or lock a row in the locked tables or lock the locked tables until the lock is released (transaction committed), i.e. until the synchronization process is finished.

Note that table locks do not block the tables from reading.

RadioButton Use serializable transaction

Enables the SERIALIZABLE Isolation Level mode for the synchronization process.

Bear in mind that a row that has been changed and committed by another transaction after the serialized transaction began will cause the serialized transaction to fail.

Note that this option can only be used if you login as NORMAL.

Number of comparison threads

Specify the number of comparison threads (max 5).

When table comparison is complete the Summary dialog appears. This dialog provides you with common information about the result of table(s) comparison. The number of identical, different, missing and additional records for each pair of tables can be found at the corresponding columns of this report.

Step 2 - Summary report

Check the Do not show summary option if there is no need in this dialog. The Show summary dialog after comparison option at the preferences dialog allows you to manage this dialog appearance. You can sort data in a column by clicking the column caption.

When you are done, press the Next button to proceed to the next step.


Using the context menus

For your convenience the context menus are implemented in the Setting table correspondence and the Setting field correspondence grids within Step 2 of the wizard.

To call a context menu, use standard Windows means (right-click the grid or use the Shift+F10 shortcut).

The context menu of the Setting table correspondence grid allows you to:

Step 2 - Tables grid - Context menu

  • clear all table correspondences;
  • clear the selected table correspondences (Hint: selection of two or more rows in the grid is performed with the Ctrl or the Shift key pressed);
  • find the matching table name in the list of available tables and set the table into correspondence with the selected one.

The context menu of the Setting field correspondence grid allows you to:

Step 2 - Fields grid - Context menu

  • clear all field correspondences for the selected table;
  • clear the selected field correspondences (Hint: selection of two or more rows in the grid is performed with the Ctrl or the Shift key pressed);
  • set all fields of the table as key fields for the comparison process;
  • unset all key fields.


Step 3 - Browsing data comparison results

At this step the results of data comparison are represented. You can set options for each of the tables being compared.

Step 3 - Browsing data comparison results

Table name

The drop-down list of available tables allows you to select a pair of tables to view their data comparison results.

In the Synchronize column the pairs to be compared are checked.

Step 3 - Browsing data comparison results_Synchronize

The header of the Key field specified at the previous step is marked out with bold font.

All data records are divided into several groups distinguished by different colors in the data comparison result grid:

identical records are the same in both tables;

different records are those having different data in one or more fields (text of different records is marked out with bold font);

missing records are the records found in the table of the source database, but not in the table of the target one;

additional records are the records found in the table of the target database, but missing in the table of the source one.

Note: To view the BLOB data, you can use internal BLOB viewer. To learn more, see Viewing BLOB data.

Use the check boxes column to filter records that you want to synchronize. If the record is checked then it will be changed in the target table.

You can sort data by the needed column. Simply click a column title to sort the data.

Use the following options to filter data:

CheckBox View identical records

Select this option to view records which are identical in source dataset and target one.

CheckBox View different records

Select this option to view records which vary from the source dataset to the target dataset.

CheckBox Missing records

Use this option if records missing from the source dataset should be displayed at the comparison result list.

CheckBox Additional records

Enable this option to view records missing from the target dataset.

Number of records on page

This value determines the quantity of records displayed as one page in the grid.

Use the btnGoToFirstPage btnGoToPreviousPage btnGoToNextPage btnGoToLastPage buttons for navigation through the pages.

To apply changes in filtering or Number of records on page options, you should use the Refresh result list btnRefresh button.

Summary

Pressing the Summary button allows you to preview the result of object comparison.

Step 3 - Browsing data comparison results_summary

If an error occurs, the line is highlighted red. The error type is displayed in the hint that appears when moving the cursor over the error.

If necessary, you can iconExportResultList Export comparison results to MS Excel, HTML, RTF using the corresponding dialog. See the Exporting comparison results page to learn more about this feature.

When you are done, press the Next button to proceed to the next step.


Viewing BLOB data

Data Comparer for Oracle provides a BLOB viewer for browsing the content of BLOB (Binary Large Object) fields being compared.

The tool can be invoked from the data grid at Step 3 by clicking the ellipsis btnEllipsis button next to a record of the BLOB field. Use the combo-box control in the upper area of the viewer to specify the field for viewing.

Please note that BLOB Viewer is only available if the Compare BLOB values option has been checked at Step 2 of the wizard.

When working with the BLOB viewer, you can use the drop-down list in the top left corner of the window for quick navigation.

The drop-down list allows you to switch the source/target fields easily.

BLOB viewer - Navigation in BLOB viewer

Switch between the BLOB viewer tabs to explore the field content.

The Hexadecimal tab allows you to view the BLOB data as hexadecimal dump.

BLOB viewer - Viewing as Hexadecimal

The Text tab allows you to view the BLOB data as plain text.

BLOB viewer - Viewing as Text

Specify text encoding in the Encoding drop-down list.

The Rich Text tab allows you to view the BLOB data in Rich Text format (RTF).

BLOB viewer - Viewing as Rich Text

The Image tab allows you to view the BLOB data as an image.

The HTML tab allows you to view the BLOB data as HTML (Hyper-Text Markup Language format) - in the way this data would be displayed by your Internet browser.

BLOB viewer - Viewing as HTML

The Multimedia tab allows you to view the BLOB data as a multimedia (audio/video) file.

Use the Play btnMultimediaPlay , Pause btnMultimediaPause , Stop btnMultimediaStop buttons to navigate within the multimedia content.

BLOB viewer - Viewing as Multimedia

Having finished browsing the BLOB data, you can close the editor and continue browsing data comparison results in the grid.

See also:

Exporting comparison results


Exporting comparison results

When the comparison process is finished, you can export comparison results using the corresponding dialog.

To open the dialog, use the Export btnExportResultList button which is available under the grid, on the right.

Step 3 - Exporting comparison results

Export type

RadioButton Current table - export comparison results for the current table only.

RadioButton All Tables - export comparison results for all tables.

Export directory

Type in or use the btnExplorer button to specify the output directory name and its location using the standard Save As... dialog.

Export format

This group allows you to select format of the output file:

RadioButton MS Excel

RadioButton RTF

RadioButton HTML

RadioButton MS Excel 97-2003

Record types

Use this group to define which records should be exported to the specified file:

CheckBox Identical records (colored [image] in the grid)

CheckBox Missing records (colored [image] in the grid)

CheckBox Different records (colored [image] in the grid)

CheckBox Additional records (colored [image] in the grid)

If necessary, you can check the CheckBox Open output file after export option to open the result file with the associated program.

Click the Export button to perform the operation. For your convenience the progress bar displays the operation progress.


Step 4 - Specifying data synchronization options

At this step you can specify advanced data synchronization parameters.

Table synchronization options

These options define the direction of synchronization: from the source to the target or vice versa.

CheckBox Synchronize in new table

Check this option to create a new table with the synchronization applied. In this case the name of the new table will be composed of the name of the source table and the user-defined postfix (_sync by default).

CheckBox Insert additional records

Set this option to insert additional records to the destination tables.

CheckBox Delete missing records

Set this option to delete missing records from the destination tables.

CheckBox Update different records

Set this option to correct different records during the synchronization process.

CheckBox Disable triggers

By setting this option you can disable triggers to avoid undesirable effects during data synchronization.

Note: Turn off the Synchronize in new table option to enable this option.

CheckBox Disable foreign keys

By setting this option you can disable foreign keys to avoid undesirable effects during data synchronization.

Note: Turn off the Synchronize in new table option to enable this option.

Step 4 - Specifying data synchronization options

Transaction preferences

RadioButton Commit after synchronization

Use this option to commit transaction only when the entire synchronization process is complete. If an error occurs during synchronization, it will be possible to rollback all the changes made.

RadioButton Commit after ... records

Define the number of records in each block of the synchronization script to be supplemented with the COMMIT statement.

Table synchronization order

RadioButton Using dependencies

If this option enabled, synchronization order will be defined automatically according to table dependencies.

RadioButton Manually

In this case synchronization order must be defined manually at Step 5.

CheckBox View synchronization script

If you select this option you will be able to view/edit the synchronization script at Step 6. Otherwise the next step will be skipped, and you will be forwarded to Step 7 upon pressing the Next button.

When you are done, press the Next button to proceed to the next step.


Step 5 - Setting synchronization order

Use this step of the wizard to set table synchronization order. It is available only if the manual table synchronization order option was selected at the previous step.

Use the up btnUp and down btnDown buttons or drag and drop move the selected table pair in the list.

Step 5 - Setting synchronization order

Click the Next button to proceed with the next step of the wizard.


Step 6 - Editing synchronization script

This step of Data Comparer wizard allows you to view and edit the synchronization script. This step is only available if the CheckBox View synchronization script option has been selected at Step 4.

Using the Script Editor area you can perform basic editing operations and / or toggle comments.

If necessary, you can save the result synchronization script to an external *.sql file using the Shift+Ctrl+S shortcut or the btnSaveScript Save as... toolbar button.

Step 6 - Editing synchronization script

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented.

The context menu of SQL Script Editor area contains most of the standard text-processing functions (Cut, Copy, Paste, Select All) and functions for working with the script as a whole, e.g. you can toggle bookmarks, move the cursor to a particular line. Most of these operations can be also performed with the corresponding hot keys used.

Implementation of the Find Text / Replace Text dialogs and Incremental search bar contributes to more efficient work with the SQL code.

When you are done, press the Next button to proceed to the next step.


Using the Find Text dialog

The Find Text dialog is provided for quick and flexible searching for specified text within the Script Editor working area.

To open this dialog, use the Ctrl+F shortcut or press the corresponding Find Text btnFindText button on the toolbar. This item is also available in the context menu of the Script Editor area.

Text to find

Enter a search string in this box. The Arrow-Down button which can be found next to the input box allows you to select any of the previously entered search strings.

Options

CheckBox Case sensitive

This option can be used to differentiate uppercase characters from lowercase ones during the search process.

CheckBox Whole words only

Use this option to search for words only (with this option off, the search string might be found within longer words.)

CheckBox Regular expressions

Recognizes regular expressions in the search string.

Direction

RadioButton Forward

Searches from the current position to the end of the Script Editor area.

RadioButton Backward

Searches from the current position to the beginning of the Script Editor area.

Scope

RadioButton Global

Searches within the entire Script Editor working area, in the direction specified by the Direction setting.

RadioButton Selected text

Searches only within the currently selected text, in the direction specified by the Direction setting. You can use the mouse or block commands to select a block of text.

Origin

RadioButton From cursor

The search starts at the cursor's current position, and then proceeds either forward to the end of the scope, or backward to the beginning of the scope depending on the Direction setting.

RadioButton Entire scope

The search covers either the entire block of selected text or the entire script (no matter where the cursor is in the Editor area) depending upon the Scope options.

CheckBox Mark search result with stack marker

The option toggles marking search results. If this option is selected, stack markers are set at all search positions - this makes it possible to jump from one marker (search result) to another within the text.

Click the Show All button to highlight every occurrence of the search string.

See also:

Using the Replace Text dialog


Using the Replace Text dialog

The Replace Text dialog is provided for searching and replacing text within the Script Editor working area.

To open this dialog, use the Ctrl+R shortcut or press the corresponding Replace Text btnReplaceText button on the toolbar. This item is also available in the context menu of the Script Editor area.

Text to find

Enter a search string in this box. The Arrow-Down button which can be found next to the input box allows you to select any of the previously entered search strings.

Text to replace

This box allows you to enter a string to replace the search string. The Arrow-Down button which can be found next to the input box allows you to select any of the previously entered strings. To replace the search string with an empty string, leave this input box blank.

Options

CheckBox Case sensitive

This option can be used to differentiate uppercase characters from lowercase ones during the search process.

CheckBox Whole words only

Use this option to search for words only (with this option off, the search string might be found within longer words.)

CheckBox Regular expressions

Recognizes regular expressions in the search string.

CheckBox Replace with template

This option requires the Regular expressions option selection.

Enable this option to use regular expressions in the Text to replace field. Expression used in this field will be applied to each string that matches the Text to find expression.

Note: The syntax of regular expressions that can be used in the Text to find and the Text to replace fields is similar to that used in Perl regular expressions. Comprehensive information about it can be found at http://perldoc.perl.org/perlre.html#Regular-Expressions.

CheckBox Prompt on replace

Check this option if you wish to be prompted before replacing upon each occurrence of the search string. When this option is off, the search string is replaced automatically.

Scope

RadioButton Global

Searches and replaces within the entire Script Editor working area, in the direction specified by the Direction setting.

RadioButton Selected text

Searches and replaces only within the currently selected text, in the direction specified by the Direction setting. You can use the mouse or block commands to select a block of text.

Direction

RadioButton Forward

Searches and replaces from the current position to the end of the Script Editor area.

RadioButton Backward

Searches and replaces from the current position to the beginning of the Script Editor area.

Origin

RadioButton From cursor

The search and replace process starts at the cursor's current position, and then proceeds either forward to the end of the scope, or backward to the beginning of the scope depending on the Direction setting.

RadioButton Entire scope

The search and replace process covers either the entire block of selected text or the entire script (no matter where the cursor is in the Editor area) depending upon the Scope options.

CheckBox Mark search result with stack marker

The option toggles marking search results. If this option is selected, stack markers are set at all search positions - this makes it possible to jump from one marker (search result) to another within the text.

Click the Replace All button to replace every occurrence of the search string. If you have checked the Prompt on replace option, the confirmation dialog box appears upon each occurrence of the search string.

See also:

Using the Find Text dialog


Step 7 - Specifying additional scripts

This step allows you to specify additional scripts to be executed for the source database before and/or after the main synchronization script execution.

Use the respective editors to create scripts: Before synchronization script and After synchronization script.

The statements can be typed in directly or pasted from the clipboard (use the context menu of the editing area for this purpose).

The Save and Load buttons provide saving/loading script file operations for the current editor window. The Clear button erases the text and clears the current editor window.

Step 7 - Specifying additional scripts

When you are done, press the Next button to proceed to the last step of the wizard.


Step 8 - Start of synchronization process

This step is intended to inform you that all the synchronization parameters have been set, and you can now start the synchronization process itself.

CheckBox Abort synchronization on error

If this option is selected, the synchronization process is stopped upon any execution error.

CheckBox Detailed error messages

Tick off the checkbox to get the detailed error log displayed on the screen. The statements for which the execution resulted in errors will be listed in the Data synchronization log area.

Step 8 - Start of synchronization process

If everything is correct, press the Synchronize button to start the process. If you want to change any options, you can return to any of the wizard steps using the Back button.

You can btnSaveLog save process log into *.rtf file or btnPrintLog print it instantly using the corresponding buttons.

Note: When you press the btnPrintLog print button, the utility saves the current log text as a temporary *.rtf file to open it with the editor that is associated with this file extension in OS and then print.

Please do not forget to save comparison templates if you need to repeat the synchronization process with the same or similar settings later.


Using Configuration Files (Templates)

Data Comparer for Oracle allows you to store its comparison and synchronization settings in external template (*.edc) files if you need to perform the data comparison/synchronization process repeatedly.

You can load a previously saved template to the application wizard if you need to make some changes before data comparison, or you can run it with the console application for quicker comparison/synchronization.

  • Saving templates
  • Loading templates
  • Restore Wizard

Additionally to the GUI version which is implemented in the form of a wizard application, the installation package of Data Comparer for Oracle includes the console version which is intended for being run from Windows command line with a template file name used as the execution parameter.

Data Comparer for Oracle command line utility is intended for quick and powerful data comparison of Oracle tables.

  • Using the console application

See also:

Using application wizard

Setting program preferences


Saving templates

Data Comparer templates are saved within the Save template options dialog. To open this dialog, press the Tools button and select the Save template popup menu item.

Templates can be saved at every step of the wizard.

Save template options

File name

Type in or use the btnSaveAs button to specify the template file name and its location using the standard Save As... dialog.

Comment

If necessary, set a comment for your template file in this field.

Using templates - Save template options

Password options

CheckBox Save password in template

Set this option to remember the password(s) for accessing the database(s).

If this option is disabled, the password is prompted upon template load.

See also:

Loading templates


Loading templates

Data Comparer templates are loaded within the Open template dialog. To open this dialog, press the Tools button and select the Load template popup menu item.

Please note that you can reopen a template at any step of the wizard using the corresponding popup menu item of the Tools menu.

You can Clear template list and Clear not existing templates using corresponding menu items.

When the template file is loaded, you are immediately forwarded to the Editing synchronization script step of the wizard. If necessary, you can return to any of the previous steps to make appropriate changes, or proceed to the last step of the wizard to start the synchronization process.

See also:

Saving templates


Using Console Application

All the comparison options are set in template (*.edc) files. A template can be also used in the Console version of Data Comparer for Oracle.

To create a template file, follow the instructions below:

  • start Data Comparer for Oracle Application wizard;
  • set all the required options in all steps of the wizard;
  • test the comparison and synchronization process at the last step;
  • save all comparison and synchronization options in the template.

The easiest way to start Data Comparer for Oracle console application is to double-click the generated *.edc template. The other way is to enter the command line and type the appropriate command.

Usage:

<path to Data Comparer for Oracle console application>\OraDataComparerC.exe TemplateFile [-L] [-B]

TemplateFile

Stands for the *.edc template file to be used as the console version execution parameter

[-L]

Selects current localization set in Wizard Application (GUI)

[-B]

Use this parameter in the command line to run the console version of Data Comparer for Oracle in the background mode

[-LOG]

This parameter sets path to the log file. By default the log is written to the program's folder.

Example:

"C:\Program Files\EMS\Data Comparer for Oracle\OraDataComparerC.exe" "C:\EMS\DataComparer\1st_sync.edc" -L -LOG"C:\Logs\datacomparer.log"

Note: The following exit codes can be returned by Data Comparer for Oracle to the operating system after performing the latest task:

0 - successful completion;

1 - error(s) occurred during task performing;

See also:

Using GUI application

Configuration file format


Setting Program Preferences

Data Comparer for Oracle provides full customization of the program by setting various options within the Preferences dialog. This chapter is intended to inform you how to use all these options.

General

These options define general behavior of Data Comparer for Oracle.

Directories

On this page you can specify the directory into which cache will be loaded.

Language

On this page you can select a language to be applied to the GUI for your copy of Data Comparer for Oracle.

See also:

Using application wizard

Using templates


General

General

Theme

Select the main color theme for the application: Light or Dark.

CheckBox Remember password

Set this option to remember the password(s) for accessing the database(s).

CheckBox Show table definition hints

This option enables/disables popup definition hints for the tables upon moving the cursor on their aliases (the Set tables and fields correspondence step of the wizard).

CheckBox Save current options on exit

Setting this option allows you to save all the comparison options automatically upon closing the application.

CheckBox Show summary dialog after comparison

If this option is enabled, comparison summary report will be displayed at Step 2.

CheckBox Show schema selection dialog

If this option is checked, the list of Oracle database schemas is displayed before you proceed to Step 2 of the wizard. The list allows you to select schemas to be refreshed.

Preferences - General

Messages

CheckBox Confirm exit

Enables/disables confirmation upon exiting the program.

CheckBox Show complete message

If this option is selected, the application returns the complete message when data synchronization process is completed at the Start of synchronization process step of the wizard.

CheckBox Show all identical tables warning

Toggles displaying the warning message in case the compared tables are identical.

CheckBox Confirm recompare

If this option is selected, on attempt to re-compare data (e.g. when you need to return to Step 2 to change tables and/or fields correspondence) you will be prompted to confirm this action.

CheckBox Show trigger disabling dialog

If this option is checked then the warning message asking about disabling triggers on synchronization is appeared after Step 4.

See also:

Directories

Language


Directories

CheckBox Use custom directory for cache

If this option is enabled, cache is loaded into user's folder specified at Cache directory. Recommended if no free space is left on the system disk. If it's off, cache is loaded into the Temp folder of the current user.

Preferences - Directories

See also:

General

Language

Data font


Language

The Language page is provided for managing Data Comparer localization files.

You can specify your own localization file by creating *.lng file similar to those available in the %program_directory%\Languages folder and place it there. After it your language will be added to the list of available languages.

In the Languages area the list of available languages and the names of the corresponding localization (*.lng) files is displayed. Here you can choose the preferable language.

Language directory

Use the ellipsis btnEllipsis button to specify the directory where the *.lng files are stored by default.

Preferences - Localization

See also:

General

Directories


Advanced connectionon settings

You need the installed Oracle client on the client computer where Data Comparer for Oracle will be used. The version of the Oracle client should be compatible with the version of Oracle server you need to connect to.

You need to add the connection settings of Oracle server databases to your TNS names file (tnsnames.ora file), which is a configuration file that contains databases description.

If you use Database Client the tnsnames.ora file is located in the %HOME_name\NETWORK\ADMIN directory.

If you use Instant Client for Oracle, you should create tnsnames.ora file manually. File should be created in the same directory where Oracle instant client is installed (e.g. C:\OracleInstantClient\). This file can be created using any text editor: create a simple text file and then change its name and extension.

Only for Instant Client: After the tnsnames.ora file is created and database description is added, create TNS_ADMIN environment variable. For this please do the following:

  1. Right-click 'My computer'.
  2. Select 'Properties' menu item.
  3. Proceed to the 'Advanced' tab and press 'Environment Variables' button.
  4. Press 'New...' button in the 'System variables' section.
  5. Set 'Variable name:' TNS_ADMIN, 'Variable value:' C:\OracleInstantClien\tnsnames.ora
  6. Press 'OK' button to save the variable.

Find PATH variable in the same dialog, double-click it and add path to the Oracle Instant client libraries (they are located in the directory where the client is installed, i.e. C:\OracleInstantClient\). Remember that the paths entries should be separated with semicolons ( ; ).

Data Comparer for Oracle connects to the server (with the help of Oracle client) via TCP/IP protocol. Here is an example of TCP/IP connection specified in TNS names file:

DB_Alias =

(DESCRIPTION =

(ADDRESS_LIST =

(ADDRESS = (PROTOCOL = TCP)(HOST = Host_name)(PORT = 1521))

)

(CONNECT_DATA =

(SERVER = DEDICATED)

(SERVICE_NAME = Database_Name)

)

)

PROTOCOL is the keyword that identifies the specific protocol adapter used. For this protocol, the value is TCP. The value can be entered in either uppercase or lowercase.

HOST is the host name or IP address.

PORT is the TCP/IP port number.

SERVICE_NAME is the name of service on server; the database instance name may differ from the actual database name, but generally the names match.

DB_Alias is any name of the connection

At the first step select Oracle client HOME in Database home drop-down list and select database from the Database drop-down list. The databases names are taken from the tnsnames.ora file.


SSH tunneling options

To setup the connection via SSH tunnel, input the following values in the corresponding fields:

  • SSH host name is the name of the host where SSH server is running
  • SSH port indicates the port where SSH server is activated
  • SSH user name stands for the user on the machine where SSH server is running (Note: it is a Linux/Windows user, not a user of Oracle server)
  • SSH password is the Linux/Windows user password

CheckBox Use Private Key for authentication

If the SSH encryption is enabled on the SSH server, a user can generate a pair of cryptographic keys (the Private key and the Public key). The Public key is placed on the SSH server, and the Private key is the part you keep secret inside a secure box that can only be opened with the correct passphrase (or an empty string as the passphrase). When you wish to access the remote system, you open the secure box with your passphrase (if any), and use the private key to authenticate yourself with the Public key on the remote Linux computer.

SSH Key file

Specify the location (the secure box) of the Private key file on your local machine.

Supported Private Key file formats are:

OpenSSH

Putty

SSH.com

Note that you need to trust your local machine not to scrape your passphrase or a copy of your Private key file while it is out of its secure box.

SSH Private Key - Passphrase


Configuration file format

The configuration (template) file used by Data Comparer for Oracle is divided into several sections, each corresponding to a particular group of settings specified at different steps of the GUI application wizard.

[#General#]

This section stores general information about the utility:

Parameter | Description
Product | internal product name
Version | major version

[#SourceDB#]

This section stores connection parameters for the source database. The parameters correspond to the values entered at Step 1 of the Wizard application and are obligatory.

Parameter | Description
DBName | source database name as specified in the TNS file
Login | Oracle login (if NTAuth = 0)
Password | password to identify the login (encrypted)
NTAuth | type of authentication: 0 = Server authentication 1 = Windows authentication
OracleHome | Oracle Home storage
ConnectAs | 0 = Normal 1 = SYSDBA 2 = SYSOPER
OptimizeGoalType | 0 = Unchanged 1 = Choose 2 = FirstRows 3 = AllRows 4 = Rule
TunnelType | indicates whether SSH tunneling is used for connection or not (TunnelType = ttNotUse)
SSHHostName | name of the host where SSH server is running
SSHPort | port on which SSH server is activated
SSHUserName | user on the machine where SSH server is running
SSHPassword | password to identify SSH server user (encrypted)
SSHKeyFile | path to the Private Key used for the SSH connection (if SSHUseKeyFile = True)
SSHUseKeyFile | True = SSH Private Key is used False = SSH Private Key is not used

[#TargetDB#]

This section stores connection parameters for the target database. The parameters correspond to the values entered at Step 1 of the Wizard application and are obligatory. The set of parameters is the same as for the source database ([#SourceDB#]).

[#Options#]

This section stores comparison options. The parameters correspond to the values specified at Step 2 and Step 3 of the Wizard application.

Parameter | Description
Blobs | 0 = BLOB fields are not specified for comparison 1 = BLOB fields are specified for comparison
IgnoreCase | 0 = case is considered when comparing strings 1 = case is ignored when comparing strings
FillIdentical | 0 = identical records are not displayed at Step 3 of the wizard 1 = identical records are displayed at Step 3 of the wizard
ViewRecordsCount | number of records displayed on one page at Step 3 of the wizard
ThreadCount | number of comparison threads
SavePassword | 0 = Password is not saved in template file 1 = Password is saved in template file
PasswordEncripted | 0 = Password is not encrypted in template file 1 = Password is encrypted in template file
TrimCharFields | 0 = CHAR fields are trimmed on synchronization 1 = CHAR fields are not trimmed on synchronization
CompareOnServerSide | 0 = comparison is performed on the client 1 = comparison is performed on the server

[#SyncOptions#]

This section stores synchronization options. The parameters correspond to the values specified at Step 4 and Step 7 of the Wizard application.

Parameter | Description
TargetToSource | 0 = synchronization from source to target 1 = synchronization from target to source
TablePostfix | postfix added to the synchronization table name (if SyncInNewTable = 1), by default _sync
SaveScript | 0 = synchronization script is saved to an external file upon saving template 1 = synchronization script is not saved
DisableTriggers | 0 = table triggers are not considered 1 = table triggers are disabled during synchronization (if SyncInNewTable = 0)
ScriptFileName | path to the file into which the synchronization script is saved (if SaveScript = 0)
InsertMissRecs | 0 = missing records are ignored during synchronization 1 = missing records are inserted during synchronization
DeleteAddRecs | 0 = additional records are ignored during synchronization 1 = additional records are deleted during synchronization
UpdateDiffRecs | 0 = different records are ignored during synchronization 1 = different records are updated during synchronization
SyncInNewTable | 0 = synchronization is performed in the source (if TargetToSource = 1) or in the target (if TargetToSource = 0) table 1 = a new table is created and the synchronized data are inserted into the table
CreateComputed | the parameter is not used by Data Comparer for Oracle
LoadToScriptEditor | 0 = synchronization script is not loaded to Script Editor 1 = synchronization script is loaded to Script Editor and displayed at Step 5 of the wizard
AbortExecuteOnError | 0 = synchronization process is not stopped if an error occurs 1 = synchronization process is stopped upon any execution error
DetailErrors | 0 = detailed error log is not displayed 1 = detailed error log is displayed on the screen at Step 7 of the wizard
ExecuteScript | 0 = synchronization script is not executed automatically 1 = synchronization script is executed automatically by the console version after template creation
DropIndexes | the parameter is not used
CommitAlter | number of committed records in the synchronization script

[#Comment#]

This section stores the template file comment as specified optionally in the Save template options dialog:

Parameter | Description
Line<N> | comment text

where N stands for the comment line identifier

Example:

Line0=Data Comparer for Oracle

Line1=Template file

Line2=Data synchronization #1

[#SrcAfterScript#]

This section stores the text of the script executed for the source database after data synchronization, as specified at Step 6 of the Wizard application.

Parameter | Description
Item_Count | number of lines
Line<N> | script text

where N stands for the script line identifier

Example:

Item_Count=2

Line0=/*AFTER synchronization*/

Line1=/*script to be executed for the source database*/

[#TrgAfterScript#]

This section stores the text of the script executed for the target database after data synchronization, as specified at Step 6 of the Wizard application.

Parameter | Description
Item_Count | number of lines
Line<N> | script text

where N stands for the script line identifier

Example:

Item_Count=2

Line0=/*AFTER synchronization*/

Line1=/*script to be executed for the target database*/

[#SrcBeforeScript#]

This section stores the text of the script executed for the source database before data synchronization, as specified at Step 6 of the Wizard application.

Parameter | Description
Item_Count | number of lines
Line<N> | script text

where N stands for the script line identifier

Example:

Item_Count=2

Line0=/*BEFORE synchronization*/

Line1=/*script to be executed for the source database*/

[#TrgBeforeScript#]

This section stores the text of the script executed for the target database before data synchronization, as specified at Step 6 of the Wizard application.

Parameter | Description
Item_Count | number of lines
Line<N> | script text

where N stands for the script line identifier

Example:

Item_Count=2

Line0=/*BEFORE synchronization*/

Line1=/*script to be executed for the target database*/

[#SpecOptions#]

This section stores some server-specific options.

Parameter | Description
UseTransaction | 0 = tables are blocked with the LOCK TABLES statement during the comparison/synchronization session 1 = serialized transaction is used for data comparison/synchronization

[SrcSchemas]

This section stores the list of source database schemas specified for comparison.

Parameter | Description
Item_Count | number of schemas
Line<N> | schema name

where N stands for the schema item identifier in the list

Example:

Item_Count=1

Line0=DEMO

[TrgSchemas]

This section stores the list of target database schemas specified for comparison.

Parameter | Description
Item_Count | number of schemas
Line<N> | schema name

where N stands for the schema item identifier in the list

Example:

Item_Count=2

Line0=TEST

Line1=PRODUCTION

[Table<N>]

Sections of this type contain table/field correspondences (N stands for the correspondence identifier), as specified at Step 2 of the Wizard application.

Parameter | Description
#SourceTable# | source table name
#TargetTable# | target table name
Synchronize | 0 = tables will not be synchronized 1 = tables #SourceTable# and #TargetTable# are specified for synchronization
#SourceOwner# | schema/owner of the source table (#SourceTable#)
#TargetOwner# | schema/owner of the target table (#TargetTable#)
<field_name> | corresponding target table field
<field_name>_CompareKey | 0 = the field is not used as key column for data comparison 1 = the field is used as key column for data comparison

Example:

[Table0]

#SourceTable#=EMPLOYEE

#TargetTable#=EMPLOYEE_UPD

Synchronize=1

#SourceOwner#=DEMO

#TargetOwner#=PRODUCTION

EMP_ID=EMP_NO

EMP_ID_CompareKey=1

FIRST_NAME=FIRST_NAME

FIRST_NAME_CompareKey=0

LAST_NAME=LAST_NAME

LAST_NAME_CompareKey=0